/* ppi(4) IEEE1284 Bulb timer SW */
/* for PENTAX *istD. May be another digital SLRs. */
/* 2004/01/25 by kaz */
/* How to make: c99 -O this.c */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <dev/ppbus/ppi.h>
#include <signal.h>

#define ON	0
#define PORT	"/dev/ppi0"

int fd;
u_int8_t ct, dt, st;		// ppi I/O data

void usage(char *myname){
	printf("Usage: %s seconds [-r]\n"
		"\t-r: reverse logic\n",myname);
	exit(1);
}

void quit(){
	ioctl( fd, PPISDATA, &dt );	/* Ϫнλ */
	close( fd );
	exit(0);
}

int main(int ac,char **av){
	u_int	sec;

	if(ac==1) usage(av[0]);

	fd = open( PORT, O_RDWR );
	if( fd < 0 ) {
		perror( PORT );
		fprintf(stderr,"Check owner & SetUID\n");
		exit( 1 );
	}

/* argsϡError check!! */
	sec=atoi(av[1]);
	if(sec<=0)	usage(av[0]);

	dt = ON;			/* ϥǡ ӥå0 */
	if(ac==3 && av[2][1]=='r')	/* ȿž */
		dt =~ dt;

	ct = 0x0b;			/* ݡȤϤ */
	ioctl( fd, PPISCTRL, &ct );

	ioctl( fd, PPISDATA, &dt );	/* Ϫг */

	dt =~ dt;			/* ϥǡ ӥå1 */
	signal(SIGTERM,quit);		/* ۾ｪλк */
	signal(SIGINT,quit);		/* к */

	sleep(sec);			/* Ϫ */

	ioctl( fd, PPISDATA, &dt );	/* Ϫнλ */

	close( fd );
	return 0;
}

/*
ѥݡȤ˥ǥ(PENTAX *istD)Ҥ֥뤳ȡ
2-9pinDATA,18-25GND,FG

ְ㤨ꡢ٤Ų᤮ꤹȡPCǥ»
줬ͭ롣ʬƥǳǧƤ顢ʵҤ

ľܥѥݡȤˤϷҤ֤Tr1Ф˥졼ޤ
Ҥ
ϼȴľ뤷ưƤ뤬ɤҤϿʤ褦ˡ

ŷλƤξϡȾפʤΤǡǾbitȤɤ
⤷i8254 or i8255γbitФƤޤäƤ⡢ޤ7bit
Τ7bit ASCIIץ󥿤Ȥ롣

ʾ塢ƼǤǡʤ»Ƥ⡢ΥġκԤǤ
ڤǤʤ
Absolutely NO warranty!
*/
